package cours
{

	import starling.utils.Color;
	import starling.text.BitmapFont;
	import starling.textures.Texture;
	import flash.display.Bitmap;
	import flash.text.Font;

	import starling.text.TextField;
	import starling.display.Sprite;
	import starling.events.Event;

	public class GameTexteBitmap extends Sprite
	{
		[Embed(source = "../bin/fonts/scriptina_0.png")]
		private static const BitmapChars : Class;
		
		[Embed(source="../bin/fonts/scriptina.fnt", mimeType="application/octet-stream")]
		private static const ScriptinaXML : Class;

		public function GameTexteBitmap()
		{
			// attend la fin de l'initialisation de la scène
			addEventListener(Event.ADDED_TO_STAGE, onAdded);
		}

		private function onAdded(e : Event) : void
		{
			// création d'un bitmap (fichier spritesheet)
			var bitmap : Bitmap = new BitmapChars();

			// création d'une texture à partir du bitmap
			var texture : Texture = Texture.fromBitmap(bitmap);

			// création du fichier xml contenant les coordonnées de chaque caractère
			var xml : XML = XML(new ScriptinaXML());

			// enregistre la police pour la rendre accessible à l'objet TextField
			TextField.registerBitmapFont(new BitmapFont(texture, xml));
			
			var sFontName:String = "Brush Script Std";
			
			// création de l'objet TextField
			var bmpFontTF : TextField = new TextField(550, 400, "écentuééàë $ Voici du texte qui utilise une police Flash !", sFontName, 33, 0x006f77);

			// définit la taille native du ficheir png à la police, pas de scaling (déformation des images)
			bmpFontTF.fontSize = BitmapFont.NATIVE_SIZE;
			//bmpFontTF.fontSize = 36;

			// utilisation de la couleur par défaut de la texture (pas de perte de qualité visible)
			//bmpFontTF.color = Color.WHITE;
			
			// centre le texte sur la scène
			bmpFontTF.x = stage.stageWidth - bmpFontTF.width >> 1;
			bmpFontTF.y = stage.stageHeight - bmpFontTF.height >> 1;

			// affichage du texte
			addChild(bmpFontTF);
		}

	}
}